DatabaseDescriptor (apache-cassandra API)
Date: 2018-02-14

org.apache.cassandra.config

## Class DatabaseDescriptor

- java.lang.Object
- - org.apache.cassandra.config.DatabaseDescriptor

-     public class DatabaseDescriptor
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DatabaseDescriptor()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `applyAddressConfig()`
    `static void` | `applyAddressConfig(Config config)`
    `static void` | `applyEncryptionContext()`
    `static void` | `applyInitialTokens()`
    `static void` | `applyPartitioner()`
    `static void` | `applyRequestScheduler()`
    `static void` | `applySeedProvider()`
    `static void` | `applySnitch()`
    `static void` | `applyThriftHSHA()`
    `static boolean` | `backPressureEnabled()`
    `static void` | `clientInitialization()` Equivalent to `clientInitialization(true)`.
    `static void` | `clientInitialization(boolean failIfDaemonOrTool)` Initializes this class as a client, which means that just an empty configuration will be used.
    `static void` | `createAllDirectories()` Creates all storage-related directories.
    `static IEndpointSnitch` | `createEndpointSnitch(boolean dynamic, java.lang.String snitchClassName)`
    `static void` | `daemonInitialization()`
    `static void` | `disableHintsForDC(java.lang.String dc)`
    `static void` | `enableHintsForDC(java.lang.String dc)`
    `static boolean` | `enableMaterializedViews()`
    `static boolean` | `enableScriptedUserDefinedFunctions()`
    `static void` | `enableScriptedUserDefinedFunctions(boolean enableScriptedUserDefinedFunctions)`
    `static boolean` | `enableUserDefinedFunctions()`
    `static boolean` | `enableUserDefinedFunctionsThreads()`
    `static java.lang.String[]` | `getAllDataFileLocations()`
    `static java.lang.String` | `getAllocateTokensForKeyspace()`
    `static IAuthenticator` | `getAuthenticator()`
    `static IAuthorizer` | `getAuthorizer()`
    `static boolean` | `getAutoSnapshot()`
    `static BackPressureStrategy` | `getBackPressureStrategy()`
    `static int` | `getBatchlogReplayThrottleInKB()`
    `static long` | `getBatchSizeFailThreshold()`
    `static int` | `getBatchSizeFailThresholdInKB()`
    `static int` | `getBatchSizeWarnThreshold()`
    `static java.net.InetAddress` | `getBroadcastAddress()`
    `static java.net.InetAddress` | `getBroadcastRpcAddress()` May be null, please use `FBUtilities.getBroadcastRpcAddress()` instead.
    `static boolean` | `getBufferPoolUseHeapIfExhausted()`
    `static long` | `getCasContentionTimeout()`
    `static int` | `getCDCDiskCheckInterval()`
    `static java.lang.String` | `getCDCLogLocation()`
    `static int` | `getCDCSpaceInMB()`
    `static EncryptionOptions.ClientEncryptionOptions` | `getClientEncryptionOptions()`
    `static java.lang.String` | `getClusterName()`
    `static int` | `getColumnIndexCacheSize()`
    `static int` | `getColumnIndexSize()`
    `static Config.CommitFailurePolicy` | `getCommitFailurePolicy()`
    `static ParameterizedClass` | `getCommitLogCompression()`
    `static java.lang.String` | `getCommitLogLocation()`
    `static int` | `getCommitLogMaxCompressionBuffersInPool()` Maximum number of buffers in the compression pool.
    `static int` | `getCommitLogSegmentSize()` size of commitlog segments to allocate
    `static Config.CommitLogSync` | `getCommitLogSync()`
    `static double` | `getCommitLogSyncBatchWindow()`
    `static int` | `getCommitLogSyncPeriod()`
    `static long` | `getCompactionLargePartitionWarningThreshold()`
    `static int` | `getCompactionThroughputMbPerSec()`
    `static int` | `getConcurrentCompactors()`
    `static int` | `getConcurrentCounterWriters()`
    `static int` | `getConcurrentReaders()`
    `static int` | `getConcurrentViewWriters()`
    `static int` | `getConcurrentWriters()`
    `static int` | `getCounterCacheKeysToSave()`
    `static int` | `getCounterCacheSavePeriod()`
    `static long` | `getCounterCacheSizeInMB()`
    `static long` | `getCounterWriteRpcTimeout()`
    `static int` | `getCredentialsCacheMaxEntries()`
    `static int` | `getCredentialsUpdateInterval()`
    `static int` | `getCredentialsValidity()`
    `static boolean` | `getDisableSTCSInL0()`
    `static Config.DiskAccessMode` | `getDiskAccessMode()`
    `static Config.DiskFailurePolicy` | `getDiskFailurePolicy()`
    `static double` | `getDiskOptimizationEstimatePercentile()`
    `static DiskOptimizationStrategy` | `getDiskOptimizationStrategy()`
    `static double` | `getDynamicBadnessThreshold()`
    `static int` | `getDynamicResetInterval()`
    `static int` | `getDynamicUpdateInterval()`
    `static EncryptionContext` | `getEncryptionContext()`
    `static IEndpointSnitch` | `getEndpointSnitch()`
    `static boolean` | `getFileCacheRoundUp()`
    `static int` | `getFileCacheSizeInMB()`
    `static int` | `getFlushWriters()`
    `static long` | `getGCLogThreshold()`
    `static long` | `getGCWarnThreshold()`
    `static int` | `getHintedHandoffThrottleInKB()`
    `static ParameterizedClass` | `getHintsCompression()`
    `static java.io.File` | `getHintsDirectory()`
    `static int` | `getHintsFlushPeriodInMS()`
    `static Config.DiskAccessMode` | `getIndexAccessMode()`
    `static long` | `getIndexSummaryCapacityInMB()`
    `static int` | `getIndexSummaryResizeIntervalInMinutes()`
    `static java.util.Collection<java.lang.String>` | `getInitialTokens()`
    `static int` | `getInterDCStreamThroughputOutboundMegabitsPerSec()`
    `static boolean` | `getInterDCTcpNoDelay()`
    `static IInternodeAuthenticator` | `getInternodeAuthenticator()`
    `static int` | `getInternodeRecvBufferSize()`
    `static int` | `getInternodeSendBufferSize()`
    `static int` | `getKeyCacheKeysToSave()`
    `static int` | `getKeyCacheSavePeriod()`
    `static long` | `getKeyCacheSizeInMB()`
    `static java.net.InetAddress` | `getListenAddress()`
    `static java.util.Comparator<java.net.InetAddress>` | `getLocalComparator()`
    `static java.lang.String` | `getLocalDataCenter()`
    `static int` | `getMaxHintsDeliveryThreads()`
    `static long` | `getMaxHintsFileSize()`
    `static int` | `getMaxHintWindow()`
    `static int` | `getMaxMutationSize()`
    `static int` | `getMaxValueSize()`
    `static Config.MemtableAllocationType` | `getMemtableAllocationType()`
    `static java.lang.Float` | `getMemtableCleanupThreshold()`
    `static long` | `getMemtableHeapSpaceInMb()`
    `static long` | `getMemtableOffheapSpaceInMb()`
    `static long` | `getMinFreeSpacePerDriveInBytes()`
    `static long` | `getMinRpcTimeout()`
    `static long` | `getNativeTransportMaxConcurrentConnections()`
    `static long` | `getNativeTransportMaxConcurrentConnectionsPerIp()`
    `static int` | `getNativeTransportMaxFrameSize()`
    `static int` | `getNativeTransportMaxThreads()`
    `static int` | `getNativeTransportPort()`
    `static int` | `getNativeTransportPortSSL()`
    `static int` | `getNumTokens()`
    `static int` | `getOtcBacklogExpirationInterval()`
    `static int` | `getOtcCoalescingEnoughCoalescedMessages()`
    `static java.lang.String` | `getOtcCoalescingStrategy()`
    `static int` | `getOtcCoalescingWindow()`
    `static IPartitioner` | `getPartitioner()`
    `static java.lang.String` | `getPartitionerName()`
    `static int` | `getPermissionsCacheMaxEntries()`
    `static int` | `getPermissionsUpdateInterval()`
    `static int` | `getPermissionsValidity()`
    `static double` | `getPhiConvictThreshold()`
    `static long` | `getPreparedStatementsCacheSizeMB()`
    `static long` | `getRangeRpcTimeout()`
    `static Config` | `getRawConfig()`
    `static long` | `getReadRpcTimeout()`
    `static java.net.InetAddress` | `getReplaceAddress()`
    `static java.util.UUID` | `getReplaceNode()`
    `static java.util.Collection<java.lang.String>` | `getReplaceTokens()`
    `static IRequestScheduler` | `getRequestScheduler()`
    `static Config.RequestSchedulerId` | `getRequestSchedulerId()`
    `static RequestSchedulerOptions` | `getRequestSchedulerOptions()`
    `static IRoleManager` | `getRoleManager()`
    `static int` | `getRolesCacheMaxEntries()`
    `static int` | `getRolesUpdateInterval()`
    `static int` | `getRolesValidity()`
    `static java.lang.String` | `getRowCacheClassName()`
    `static int` | `getRowCacheKeysToSave()`
    `static int` | `getRowCacheSavePeriod()`
    `static long` | `getRowCacheSizeInMB()`
    `static java.net.InetAddress` | `getRpcAddress()`
    `static boolean` | `getRpcKeepAlive()`
    `static int` | `getRpcListenBacklog()`
    `static java.lang.Integer` | `getRpcMaxThreads()`
    `static java.lang.Integer` | `getRpcMinThreads()`
    `static int` | `getRpcPort()`
    `static java.lang.Integer` | `getRpcRecvBufferSize()`
    `static java.lang.Integer` | `getRpcSendBufferSize()`
    `static java.lang.String` | `getRpcServerType()`
    `static long` | `getRpcTimeout()`
    `static java.lang.String` | `getSavedCachesLocation()`
    `static java.util.Set<java.net.InetAddress>` | `getSeeds()`
    `static java.io.File` | `getSerializedCachePath(CacheService.CacheType cacheType, java.lang.String version, java.lang.String extension)`
    `static EncryptionOptions.ServerEncryptionOptions` | `getServerEncryptionOptions()`
    `static long` | `getSlowQueryTimeout()`
    `static int` | `getSSLStoragePort()`
    `static int` | `getSSTablePreempiveOpenIntervalInMB()`
    `static int` | `getStoragePort()`
    `static int` | `getStreamingKeepAlivePeriod()`
    `static int` | `getStreamingSocketTimeout()` Deprecated. use `this#getStreamingKeepAlivePeriod()` instead
    `static int` | `getStreamThroughputOutboundMegabitsPerSec()`
    `static int` | `getThriftFramedTransportSize()`
    `static long` | `getThriftPreparedStatementsCacheSizeMB()`
    `static int` | `getTombstoneFailureThreshold()`
    `static int` | `getTombstoneWarnThreshold()`
    `static long` | `getTotalCommitlogSpaceInMB()`
    `static int` | `getTracetypeQueryTTL()`
    `static int` | `getTracetypeRepairTTL()`
    `static boolean` | `getTrickleFsync()`
    `static int` | `getTrickleFsyncIntervalInKb()`
    `static long` | `getTruncateRpcTimeout()`
    `static int` | `getUnloggedBatchAcrossPartitionsWarnThreshold()`
    `static long` | `getUserDefinedFunctionFailTimeout()`
    `static long` | `getUserDefinedFunctionWarnTimeout()`
    `static Config.UserFunctionTimeoutPolicy` | `getUserFunctionTimeoutPolicy()`
    `static int` | `getWindowsTimerInterval()`
    `static long` | `getWriteRpcTimeout()`
    `static boolean` | `hasCrossNodeTimeout()`
    `static boolean` | `hasLargeAddressSpace()`
    `static java.util.Set<java.lang.String>` | `hintedHandoffDisabledDCs()`
    `static boolean` | `hintedHandoffEnabled()`
    `static Config.InternodeCompression` | `internodeCompression()`
    `static boolean` | `isAutoBootstrap()`
    `static boolean` | `isAutoSnapshot()`
    `static boolean` | `isCDCEnabled()`
    `static boolean` | `isClientInitialized()`
    `static boolean` | `isClientOrToolInitialized()`
    `static boolean` | `isDaemonInitialized()`
    `static boolean` | `isIncrementalBackupsEnabled()`
    `static boolean` | `isSnapshotBeforeCompaction()`
    `static boolean` | `isToolInitialized()`
    `static boolean` | `isUnsafeSystem()`
    `static Config` | `loadConfig()`
    `static int` | `searchConcurrencyFactor()`
    `static void` | `setAuthenticator(IAuthenticator authenticator)`
    `static void` | `setAuthorizer(IAuthorizer authorizer)`
    `static void` | `setAutoSnapshot(boolean autoSnapshot)`
    `static void` | `setBackPressureEnabled(boolean backPressureEnabled)`
    `static void` | `setBackPressureStrategy(BackPressureStrategy strategy)`
    `static void` | `setBatchSizeFailThresholdInKB(int threshold)`
    `static void` | `setBatchSizeWarnThresholdInKB(int threshold)`
    `static void` | `setBroadcastAddress(java.net.InetAddress broadcastAdd)`
    `static void` | `setBroadcastRpcAddress(java.net.InetAddress broadcastRPCAddr)`
    `static void` | `setCasContentionTimeout(long timeOutInMillis)`
    `static void` | `setCDCEnabled(boolean cdc_enabled)`
    `static void` | `setCDCSpaceInMB(int input)`
    `static void` | `setColumnIndexCacheSize(int val)`
    `static void` | `setColumnIndexSize(int val)`
    `static void` | `setCommitFailurePolicy(Config.CommitFailurePolicy policy)`
    `static void` | `setCommitLogCompression(ParameterizedClass compressor)`
    `static void` | `setCommitLogLocation(java.lang.String value)`
    `static void` | `setCommitLogMaxCompressionBuffersPerPool(int buffers)`
    `static void` | `setCommitLogSegmentSize(int sizeMegabytes)`
    `static void` | `setCommitLogSync(Config.CommitLogSync sync)`
    `static void` | `setCommitLogSyncBatchWindow(double windowMillis)`
    `static void` | `setCommitLogSyncPeriod(int periodMillis)`
    `static void` | `setCompactionThroughputMbPerSec(int value)`
    `static void` | `setConcurrentCompactors(int value)`
    `static void` | `setCounterCacheKeysToSave(int counterCacheKeysToSave)`
    `static void` | `setCounterCacheSavePeriod(int counterCacheSavePeriod)`
    `static void` | `setCounterWriteRpcTimeout(long timeOutInMillis)`
    `static int` | `setCredentialsCacheMaxEntries(int maxEntries)`
    `static void` | `setCredentialsUpdateInterval(int updateInterval)`
    `static void` | `setCredentialsValidity(int timeout)`
    `static void` | `setDiskAccessMode(Config.DiskAccessMode mode)`
    `static void` | `setDiskFailurePolicy(Config.DiskFailurePolicy policy)`
    `static void` | `setDynamicBadnessThreshold(double dynamicBadnessThreshold)`
    `static void` | `setDynamicResetInterval(int dynamicResetInterval)`
    `static void` | `setDynamicUpdateInterval(int dynamicUpdateInterval)`
    `static void` | `setEncryptionContext(EncryptionContext ec)`
    `static void` | `setEndpointSnitch(IEndpointSnitch eps)`
    `static void` | `setHintedHandoffEnabled(boolean hintedHandoffEnabled)`
    `static void` | `setHintedHandoffThrottleInKB(int throttleInKB)`
    `static void` | `setHintsCompression(ParameterizedClass parameterizedClass)`
    `static void` | `setIncrementalBackupsEnabled(boolean value)`
    `static void` | `setIndexAccessMode(Config.DiskAccessMode mode)`
    `static void` | `setInterDCStreamThroughputOutboundMegabitsPerSec(int value)`
    `static void` | `setInternodeAuthenticator(IInternodeAuthenticator internodeAuthenticator)`
    `static void` | `setKeyCacheKeysToSave(int keyCacheKeysToSave)`
    `static void` | `setKeyCacheSavePeriod(int keyCacheSavePeriod)`
    `static void` | `setMaxHintWindow(int ms)`
    `static void` | `setMaxValueSize(int maxValueSizeInBytes)`
    `static void` | `setNativeTransportMaxConcurrentConnections(long nativeTransportMaxConcurrentConnections)`
    `static void` | `setNativeTransportMaxConcurrentConnectionsPerIp(long native_transport_max_concurrent_connections_per_ip)`
    `static void` | `setNativeTransportPort(int port)`
    `static void` | `setNativeTransportPortSSL(java.lang.Integer port)`
    `static void` | `setOtcBacklogExpirationInterval(int intervalInMillis)`
    `static void` | `setOtcCoalescingEnoughCoalescedMessages(int otc_coalescing_enough_coalesced_messages)`
    `static IPartitioner` | `setPartitionerUnsafe(IPartitioner newPartitioner)`
    `static int` | `setPermissionsCacheMaxEntries(int maxEntries)`
    `static void` | `setPermissionsUpdateInterval(int updateInterval)`
    `static void` | `setPermissionsValidity(int timeout)`
    `static void` | `setPhiConvictThreshold(double phiConvictThreshold)`
    `static void` | `setRangeRpcTimeout(long timeOutInMillis)`
    `static void` | `setReadRpcTimeout(long timeOutInMillis)`
    `static void` | `setRoleManager(IRoleManager roleManager)`
    `static int` | `setRolesCacheMaxEntries(int maxEntries)`
    `static void` | `setRolesUpdateInterval(int interval)`
    `static void` | `setRolesValidity(int validity)`
    `static void` | `setRowCacheKeysToSave(int rowCacheKeysToSave)`
    `static void` | `setRowCacheSavePeriod(int rowCacheSavePeriod)`
    `static void` | `setRowCacheSizeInMB(long val)`
    `static void` | `setRpcTimeout(long timeOutInMillis)`
    `static void` | `setSSTablePreempiveOpenIntervalInMB(int mb)`
    `static void` | `setStreamingSocketTimeout(int value)`
    `static void` | `setStreamThroughputOutboundMegabitsPerSec(int value)`
    `static void` | `setTombstoneFailureThreshold(int threshold)`
    `static void` | `setTombstoneWarnThreshold(int threshold)`
    `static void` | `setTruncateRpcTimeout(long timeOutInMillis)`
    `static void` | `setUserDefinedFunctionFailTimeout(long userDefinedFunctionFailTimeout)`
    `static void` | `setUserDefinedFunctionWarnTimeout(long userDefinedFunctionWarnTimeout)`
    `static void` | `setUserFunctionTimeoutPolicy(Config.UserFunctionTimeoutPolicy userFunctionTimeoutPolicy)`
    `static void` | `setWriteRpcTimeout(long timeOutInMillis)`
    `static boolean` | `shouldListenOnBroadcastAddress()`
    `static boolean` | `startNativeTransport()`
    `static boolean` | `startRpc()`
    `static java.util.Collection<java.lang.String>` | `tokensFromString(java.lang.String tokenString)`
    `static void` | `toolInitialization()` Equivalent to `toolInitialization(true)`.
    `static void` | `toolInitialization(boolean failIfDaemonOrClient)` Initializes this class as a tool, which means that the configuration is loaded using `loadConfig()` and all non-daemon configuration parts will be setup.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DatabaseDescriptor

          public DatabaseDescriptor()

  - ### Method Detail

    - #### daemonInitialization

          public static void daemonInitialization()
                                           throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### toolInitialization

          public static void toolInitialization()

      Equivalent to `toolInitialization(true)`.

    - #### toolInitialization

          public static void toolInitialization(boolean failIfDaemonOrClient)

      Initializes this class as a tool, which means that the configuration is loaded using `loadConfig()` and all non-daemon configuration parts will be setup.
      Parameters:
        `failIfDaemonOrClient` - if `true` and a call to `daemonInitialization()` or `clientInitialization()` has been performed before, an `AssertionError` will be thrown.

    - #### clientInitialization

          public static void clientInitialization()

      Equivalent to `clientInitialization(true)`.

    - #### clientInitialization

          public static void clientInitialization(boolean failIfDaemonOrTool)

      Initializes this class as a client, which means that just an empty configuration will be used.
      Parameters:
        `failIfDaemonOrTool` - if `true` and a call to `daemonInitialization()` or `toolInitialization()` has been performed before, an `AssertionError` will be thrown.

    - #### isClientInitialized

          public static boolean isClientInitialized()

    - #### isToolInitialized

          public static boolean isToolInitialized()

    - #### isClientOrToolInitialized

          public static boolean isClientOrToolInitialized()

    - #### isDaemonInitialized

          public static boolean isDaemonInitialized()

    - #### getRawConfig

          public static Config getRawConfig()

    - #### loadConfig

          public static Config loadConfig()
                                   throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### applyAddressConfig

          public static void applyAddressConfig()
                                         throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### applyAddressConfig

          public static void applyAddressConfig(Config config)
                                         throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### applyThriftHSHA

          public static void applyThriftHSHA()

    - #### applyEncryptionContext

          public static void applyEncryptionContext()

    - #### applySeedProvider

          public static void applySeedProvider()

    - #### applyInitialTokens

          public static void applyInitialTokens()

    - #### applyRequestScheduler

          public static void applyRequestScheduler()

    - #### applySnitch

          public static void applySnitch()

    - #### applyPartitioner

          public static void applyPartitioner()

    - #### createEndpointSnitch

          public static IEndpointSnitch createEndpointSnitch(boolean dynamic,
                                                             java.lang.String snitchClassName)
                                                      throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### getAuthenticator

          public static IAuthenticator getAuthenticator()

    - #### setAuthenticator

          public static void setAuthenticator(IAuthenticator authenticator)

    - #### getAuthorizer

          public static IAuthorizer getAuthorizer()

    - #### setAuthorizer

          public static void setAuthorizer(IAuthorizer authorizer)

    - #### getRoleManager

          public static IRoleManager getRoleManager()

    - #### setRoleManager

          public static void setRoleManager(IRoleManager roleManager)

    - #### getPermissionsValidity

          public static int getPermissionsValidity()

    - #### setPermissionsValidity

          public static void setPermissionsValidity(int timeout)

    - #### getPermissionsUpdateInterval

          public static int getPermissionsUpdateInterval()

    - #### setPermissionsUpdateInterval

          public static void setPermissionsUpdateInterval(int updateInterval)

    - #### getPermissionsCacheMaxEntries

          public static int getPermissionsCacheMaxEntries()

    - #### setPermissionsCacheMaxEntries

          public static int setPermissionsCacheMaxEntries(int maxEntries)

    - #### getRolesValidity

          public static int getRolesValidity()

    - #### setRolesValidity

          public static void setRolesValidity(int validity)

    - #### getRolesUpdateInterval

          public static int getRolesUpdateInterval()

    - #### setRolesUpdateInterval

          public static void setRolesUpdateInterval(int interval)

    - #### getRolesCacheMaxEntries

          public static int getRolesCacheMaxEntries()

    - #### setRolesCacheMaxEntries

          public static int setRolesCacheMaxEntries(int maxEntries)

    - #### getCredentialsValidity

          public static int getCredentialsValidity()

    - #### setCredentialsValidity

          public static void setCredentialsValidity(int timeout)

    - #### getCredentialsUpdateInterval

          public static int getCredentialsUpdateInterval()

    - #### setCredentialsUpdateInterval

          public static void setCredentialsUpdateInterval(int updateInterval)

    - #### getCredentialsCacheMaxEntries

          public static int getCredentialsCacheMaxEntries()

    - #### setCredentialsCacheMaxEntries

          public static int setCredentialsCacheMaxEntries(int maxEntries)

    - #### getThriftFramedTransportSize

          public static int getThriftFramedTransportSize()

    - #### getMaxValueSize

          public static int getMaxValueSize()

    - #### setMaxValueSize

          public static void setMaxValueSize(int maxValueSizeInBytes)

    - #### createAllDirectories

          public static void createAllDirectories()

      Creates all storage-related directories.

    - #### getPartitioner

          public static IPartitioner getPartitioner()

    - #### getPartitionerName

          public static java.lang.String getPartitionerName()

    - #### setPartitionerUnsafe

          public static IPartitioner setPartitionerUnsafe(IPartitioner newPartitioner)

    - #### getEndpointSnitch

          public static IEndpointSnitch getEndpointSnitch()

    - #### setEndpointSnitch

          public static void setEndpointSnitch(IEndpointSnitch eps)

    - #### getRequestScheduler

          public static IRequestScheduler getRequestScheduler()

    - #### getRequestSchedulerOptions

          public static RequestSchedulerOptions getRequestSchedulerOptions()

    - #### getRequestSchedulerId

          public static Config.RequestSchedulerId getRequestSchedulerId()

    - #### getColumnIndexSize

          public static int getColumnIndexSize()

    - #### setColumnIndexSize

          public static void setColumnIndexSize(int val)

    - #### getColumnIndexCacheSize

          public static int getColumnIndexCacheSize()

    - #### setColumnIndexCacheSize

          public static void setColumnIndexCacheSize(int val)

    - #### getBatchSizeWarnThreshold

          public static int getBatchSizeWarnThreshold()

    - #### getBatchSizeFailThreshold

          public static long getBatchSizeFailThreshold()

    - #### getBatchSizeFailThresholdInKB

          public static int getBatchSizeFailThresholdInKB()

    - #### getUnloggedBatchAcrossPartitionsWarnThreshold

          public static int getUnloggedBatchAcrossPartitionsWarnThreshold()

    - #### setBatchSizeWarnThresholdInKB

          public static void setBatchSizeWarnThresholdInKB(int threshold)

    - #### setBatchSizeFailThresholdInKB

          public static void setBatchSizeFailThresholdInKB(int threshold)

    - #### getInitialTokens

          public static java.util.Collection<java.lang.String> getInitialTokens()

    - #### getAllocateTokensForKeyspace

          public static java.lang.String getAllocateTokensForKeyspace()

    - #### tokensFromString

          public static java.util.Collection<java.lang.String> tokensFromString(java.lang.String tokenString)

    - #### getNumTokens

          public static int getNumTokens()

    - #### getReplaceAddress

          public static java.net.InetAddress getReplaceAddress()

    - #### getReplaceTokens

          public static java.util.Collection<java.lang.String> getReplaceTokens()

    - #### getReplaceNode

          public static java.util.UUID getReplaceNode()

    - #### getClusterName

          public static java.lang.String getClusterName()

    - #### getStoragePort

          public static int getStoragePort()

    - #### getSSLStoragePort

          public static int getSSLStoragePort()

    - #### getRpcPort

          public static int getRpcPort()

    - #### getRpcListenBacklog

          public static int getRpcListenBacklog()

    - #### getRpcTimeout

          public static long getRpcTimeout()

    - #### setRpcTimeout

          public static void setRpcTimeout(long timeOutInMillis)

    - #### getReadRpcTimeout

          public static long getReadRpcTimeout()

    - #### setReadRpcTimeout

          public static void setReadRpcTimeout(long timeOutInMillis)

    - #### getRangeRpcTimeout

          public static long getRangeRpcTimeout()

    - #### setRangeRpcTimeout

          public static void setRangeRpcTimeout(long timeOutInMillis)

    - #### getWriteRpcTimeout

          public static long getWriteRpcTimeout()

    - #### setWriteRpcTimeout

          public static void setWriteRpcTimeout(long timeOutInMillis)

    - #### getCounterWriteRpcTimeout

          public static long getCounterWriteRpcTimeout()

    - #### setCounterWriteRpcTimeout

          public static void setCounterWriteRpcTimeout(long timeOutInMillis)

    - #### getCasContentionTimeout

          public static long getCasContentionTimeout()

    - #### setCasContentionTimeout

          public static void setCasContentionTimeout(long timeOutInMillis)

    - #### getTruncateRpcTimeout

          public static long getTruncateRpcTimeout()

    - #### setTruncateRpcTimeout

          public static void setTruncateRpcTimeout(long timeOutInMillis)

    - #### hasCrossNodeTimeout

          public static boolean hasCrossNodeTimeout()

    - #### getSlowQueryTimeout

          public static long getSlowQueryTimeout()

    - #### getMinRpcTimeout

          public static long getMinRpcTimeout()

      Returns:
        the minimum configured {read, write, range, truncate, misc} timeout

    - #### getPhiConvictThreshold

          public static double getPhiConvictThreshold()

    - #### setPhiConvictThreshold

          public static void setPhiConvictThreshold(double phiConvictThreshold)

    - #### getConcurrentReaders

          public static int getConcurrentReaders()

    - #### getConcurrentWriters

          public static int getConcurrentWriters()

    - #### getConcurrentCounterWriters

          public static int getConcurrentCounterWriters()

    - #### getConcurrentViewWriters

          public static int getConcurrentViewWriters()

    - #### getFlushWriters

          public static int getFlushWriters()

    - #### getConcurrentCompactors

          public static int getConcurrentCompactors()

    - #### setConcurrentCompactors

          public static void setConcurrentCompactors(int value)

    - #### getCompactionThroughputMbPerSec

          public static int getCompactionThroughputMbPerSec()

    - #### setCompactionThroughputMbPerSec

          public static void setCompactionThroughputMbPerSec(int value)

    - #### getCompactionLargePartitionWarningThreshold

          public static long getCompactionLargePartitionWarningThreshold()

    - #### getMinFreeSpacePerDriveInBytes

          public static long getMinFreeSpacePerDriveInBytes()

    - #### getDisableSTCSInL0

          public static boolean getDisableSTCSInL0()

    - #### getStreamThroughputOutboundMegabitsPerSec

          public static int getStreamThroughputOutboundMegabitsPerSec()

    - #### setStreamThroughputOutboundMegabitsPerSec

          public static void setStreamThroughputOutboundMegabitsPerSec(int value)

    - #### getInterDCStreamThroughputOutboundMegabitsPerSec

          public static int getInterDCStreamThroughputOutboundMegabitsPerSec()

    - #### setInterDCStreamThroughputOutboundMegabitsPerSec

          public static void setInterDCStreamThroughputOutboundMegabitsPerSec(int value)

    - #### getAllDataFileLocations

          public static java.lang.String[] getAllDataFileLocations()

    - #### getCommitLogLocation

          public static java.lang.String getCommitLogLocation()

    - #### setCommitLogLocation

          public static void setCommitLogLocation(java.lang.String value)

    - #### getCommitLogCompression

          public static ParameterizedClass getCommitLogCompression()

    - #### setCommitLogCompression

          public static void setCommitLogCompression(ParameterizedClass compressor)

    - #### getCommitLogMaxCompressionBuffersInPool

          public static int getCommitLogMaxCompressionBuffersInPool()

      Maximum number of buffers in the compression pool. The default value is 3, it should not be set lower than that (one segment in compression, one written to, one in reserve); delays in compression may cause the log to use more, depending on how soon the sync policy stops all writing threads.

    - #### setCommitLogMaxCompressionBuffersPerPool

          public static void setCommitLogMaxCompressionBuffersPerPool(int buffers)

    - #### getMaxMutationSize

          public static int getMaxMutationSize()

    - #### getTombstoneWarnThreshold

          public static int getTombstoneWarnThreshold()

    - #### setTombstoneWarnThreshold

          public static void setTombstoneWarnThreshold(int threshold)

    - #### getTombstoneFailureThreshold

          public static int getTombstoneFailureThreshold()

    - #### setTombstoneFailureThreshold

          public static void setTombstoneFailureThreshold(int threshold)

    - #### getCommitLogSegmentSize

          public static int getCommitLogSegmentSize()

      size of commitlog segments to allocate

    - #### setCommitLogSegmentSize

          public static void setCommitLogSegmentSize(int sizeMegabytes)

    - #### getSavedCachesLocation

          public static java.lang.String getSavedCachesLocation()

    - #### getSeeds

          public static java.util.Set<java.net.InetAddress> getSeeds()

    - #### getListenAddress

          public static java.net.InetAddress getListenAddress()

    - #### getBroadcastAddress

          public static java.net.InetAddress getBroadcastAddress()

    - #### shouldListenOnBroadcastAddress

          public static boolean shouldListenOnBroadcastAddress()

    - #### getInternodeAuthenticator

          public static IInternodeAuthenticator getInternodeAuthenticator()

    - #### setInternodeAuthenticator

          public static void setInternodeAuthenticator(IInternodeAuthenticator internodeAuthenticator)

    - #### setBroadcastAddress

          public static void setBroadcastAddress(java.net.InetAddress broadcastAdd)

    - #### startRpc

          public static boolean startRpc()

    - #### getRpcAddress

          public static java.net.InetAddress getRpcAddress()

    - #### setBroadcastRpcAddress

          public static void setBroadcastRpcAddress(java.net.InetAddress broadcastRPCAddr)

    - #### getBroadcastRpcAddress

          public static java.net.InetAddress getBroadcastRpcAddress()

      May be null, please use `FBUtilities.getBroadcastRpcAddress()` instead.

    - #### getRpcServerType

          public static java.lang.String getRpcServerType()

    - #### getRpcKeepAlive

          public static boolean getRpcKeepAlive()

    - #### getRpcMinThreads

          public static java.lang.Integer getRpcMinThreads()

    - #### getRpcMaxThreads

          public static java.lang.Integer getRpcMaxThreads()

    - #### getRpcSendBufferSize

          public static java.lang.Integer getRpcSendBufferSize()

    - #### getRpcRecvBufferSize

          public static java.lang.Integer getRpcRecvBufferSize()

    - #### getInternodeSendBufferSize

          public static int getInternodeSendBufferSize()

    - #### getInternodeRecvBufferSize

          public static int getInternodeRecvBufferSize()

    - #### startNativeTransport

          public static boolean startNativeTransport()

    - #### getNativeTransportPort

          public static int getNativeTransportPort()

    - #### setNativeTransportPort

          public static void setNativeTransportPort(int port)

    - #### getNativeTransportPortSSL

          public static int getNativeTransportPortSSL()

    - #### setNativeTransportPortSSL

          public static void setNativeTransportPortSSL(java.lang.Integer port)

    - #### getNativeTransportMaxThreads

          public static int getNativeTransportMaxThreads()

    - #### getNativeTransportMaxFrameSize

          public static int getNativeTransportMaxFrameSize()

    - #### getNativeTransportMaxConcurrentConnections

          public static long getNativeTransportMaxConcurrentConnections()

    - #### setNativeTransportMaxConcurrentConnections

          public static void setNativeTransportMaxConcurrentConnections(long nativeTransportMaxConcurrentConnections)

    - #### getNativeTransportMaxConcurrentConnectionsPerIp

          public static long getNativeTransportMaxConcurrentConnectionsPerIp()

    - #### setNativeTransportMaxConcurrentConnectionsPerIp

          public static void setNativeTransportMaxConcurrentConnectionsPerIp(long native_transport_max_concurrent_connections_per_ip)

    - #### getCommitLogSyncBatchWindow

          public static double getCommitLogSyncBatchWindow()

    - #### setCommitLogSyncBatchWindow

          public static void setCommitLogSyncBatchWindow(double windowMillis)

    - #### getCommitLogSyncPeriod

          public static int getCommitLogSyncPeriod()

    - #### setCommitLogSyncPeriod

          public static void setCommitLogSyncPeriod(int periodMillis)

    - #### getCommitLogSync

          public static Config.CommitLogSync getCommitLogSync()

    - #### setCommitLogSync

          public static void setCommitLogSync(Config.CommitLogSync sync)

    - #### getDiskAccessMode

          public static Config.DiskAccessMode getDiskAccessMode()

    - #### setDiskAccessMode

          public static void setDiskAccessMode(Config.DiskAccessMode mode)

    - #### getIndexAccessMode

          public static Config.DiskAccessMode getIndexAccessMode()

    - #### setIndexAccessMode

          public static void setIndexAccessMode(Config.DiskAccessMode mode)

    - #### setDiskFailurePolicy

          public static void setDiskFailurePolicy(Config.DiskFailurePolicy policy)

    - #### getDiskFailurePolicy

          public static Config.DiskFailurePolicy getDiskFailurePolicy()

    - #### setCommitFailurePolicy

          public static void setCommitFailurePolicy(Config.CommitFailurePolicy policy)

    - #### getCommitFailurePolicy

          public static Config.CommitFailurePolicy getCommitFailurePolicy()

    - #### isSnapshotBeforeCompaction

          public static boolean isSnapshotBeforeCompaction()

    - #### isAutoSnapshot

          public static boolean isAutoSnapshot()

    - #### setAutoSnapshot

          public static void setAutoSnapshot(boolean autoSnapshot)

    - #### getAutoSnapshot

          public static boolean getAutoSnapshot()

    - #### isAutoBootstrap

          public static boolean isAutoBootstrap()

    - #### setHintedHandoffEnabled

          public static void setHintedHandoffEnabled(boolean hintedHandoffEnabled)

    - #### hintedHandoffEnabled

          public static boolean hintedHandoffEnabled()

    - #### hintedHandoffDisabledDCs

          public static java.util.Set<java.lang.String> hintedHandoffDisabledDCs()

    - #### enableHintsForDC

          public static void enableHintsForDC(java.lang.String dc)

    - #### disableHintsForDC

          public static void disableHintsForDC(java.lang.String dc)

    - #### setMaxHintWindow

          public static void setMaxHintWindow(int ms)

    - #### getMaxHintWindow

          public static int getMaxHintWindow()

    - #### getHintsDirectory

          public static java.io.File getHintsDirectory()

    - #### getSerializedCachePath

          public static java.io.File getSerializedCachePath(CacheService.CacheType cacheType,
                                                            java.lang.String version,
                                                            java.lang.String extension)

    - #### getDynamicUpdateInterval

          public static int getDynamicUpdateInterval()

    - #### setDynamicUpdateInterval

          public static void setDynamicUpdateInterval(int dynamicUpdateInterval)

    - #### getDynamicResetInterval

          public static int getDynamicResetInterval()

    - #### setDynamicResetInterval

          public static void setDynamicResetInterval(int dynamicResetInterval)

    - #### getDynamicBadnessThreshold

          public static double getDynamicBadnessThreshold()

    - #### setDynamicBadnessThreshold

          public static void setDynamicBadnessThreshold(double dynamicBadnessThreshold)

    - #### getServerEncryptionOptions

          public static EncryptionOptions.ServerEncryptionOptions getServerEncryptionOptions()

    - #### getClientEncryptionOptions

          public static EncryptionOptions.ClientEncryptionOptions getClientEncryptionOptions()

    - #### getHintedHandoffThrottleInKB

          public static int getHintedHandoffThrottleInKB()

    - #### getBatchlogReplayThrottleInKB

          public static int getBatchlogReplayThrottleInKB()

    - #### setHintedHandoffThrottleInKB

          public static void setHintedHandoffThrottleInKB(int throttleInKB)

    - #### getMaxHintsDeliveryThreads

          public static int getMaxHintsDeliveryThreads()

    - #### getHintsFlushPeriodInMS

          public static int getHintsFlushPeriodInMS()

    - #### getMaxHintsFileSize

          public static long getMaxHintsFileSize()

    - #### getHintsCompression

          public static ParameterizedClass getHintsCompression()

    - #### setHintsCompression

          public static void setHintsCompression(ParameterizedClass parameterizedClass)

    - #### isIncrementalBackupsEnabled

          public static boolean isIncrementalBackupsEnabled()

    - #### setIncrementalBackupsEnabled

          public static void setIncrementalBackupsEnabled(boolean value)

    - #### getFileCacheSizeInMB

          public static int getFileCacheSizeInMB()

    - #### getFileCacheRoundUp

          public static boolean getFileCacheRoundUp()

    - #### getBufferPoolUseHeapIfExhausted

          public static boolean getBufferPoolUseHeapIfExhausted()

    - #### getDiskOptimizationStrategy

          public static DiskOptimizationStrategy getDiskOptimizationStrategy()

    - #### getDiskOptimizationEstimatePercentile

          public static double getDiskOptimizationEstimatePercentile()

    - #### getTotalCommitlogSpaceInMB

          public static long getTotalCommitlogSpaceInMB()

    - #### getSSTablePreempiveOpenIntervalInMB

          public static int getSSTablePreempiveOpenIntervalInMB()

    - #### setSSTablePreempiveOpenIntervalInMB

          public static void setSSTablePreempiveOpenIntervalInMB(int mb)

    - #### getTrickleFsync

          public static boolean getTrickleFsync()

    - #### getTrickleFsyncIntervalInKb

          public static int getTrickleFsyncIntervalInKb()

    - #### getKeyCacheSizeInMB

          public static long getKeyCacheSizeInMB()

    - #### getIndexSummaryCapacityInMB

          public static long getIndexSummaryCapacityInMB()

    - #### getKeyCacheSavePeriod

          public static int getKeyCacheSavePeriod()

    - #### setKeyCacheSavePeriod

          public static void setKeyCacheSavePeriod(int keyCacheSavePeriod)

    - #### getKeyCacheKeysToSave

          public static int getKeyCacheKeysToSave()

    - #### setKeyCacheKeysToSave

          public static void setKeyCacheKeysToSave(int keyCacheKeysToSave)

    - #### getRowCacheClassName

          public static java.lang.String getRowCacheClassName()

    - #### getRowCacheSizeInMB

          public static long getRowCacheSizeInMB()

    - #### setRowCacheSizeInMB

          public static void setRowCacheSizeInMB(long val)

    - #### getRowCacheSavePeriod

          public static int getRowCacheSavePeriod()

    - #### setRowCacheSavePeriod

          public static void setRowCacheSavePeriod(int rowCacheSavePeriod)

    - #### getRowCacheKeysToSave

          public static int getRowCacheKeysToSave()

    - #### getCounterCacheSizeInMB

          public static long getCounterCacheSizeInMB()

    - #### setRowCacheKeysToSave

          public static void setRowCacheKeysToSave(int rowCacheKeysToSave)

    - #### getCounterCacheSavePeriod

          public static int getCounterCacheSavePeriod()

    - #### setCounterCacheSavePeriod

          public static void setCounterCacheSavePeriod(int counterCacheSavePeriod)

    - #### getCounterCacheKeysToSave

          public static int getCounterCacheKeysToSave()

    - #### setCounterCacheKeysToSave

          public static void setCounterCacheKeysToSave(int counterCacheKeysToSave)

    - #### setStreamingSocketTimeout

          public static void setStreamingSocketTimeout(int value)

    - #### getStreamingSocketTimeout

          @Deprecated
          public static int getStreamingSocketTimeout()

      Deprecated. use `this#getStreamingKeepAlivePeriod()` instead
      Returns:
        streaming_socket_timeout_in_ms property

    - #### getStreamingKeepAlivePeriod

          public static int getStreamingKeepAlivePeriod()

    - #### getLocalDataCenter

          public static java.lang.String getLocalDataCenter()

    - #### getLocalComparator

          public static java.util.Comparator<java.net.InetAddress> getLocalComparator()

    - #### internodeCompression

          public static Config.InternodeCompression internodeCompression()

    - #### getInterDCTcpNoDelay

          public static boolean getInterDCTcpNoDelay()

    - #### getMemtableHeapSpaceInMb

          public static long getMemtableHeapSpaceInMb()

    - #### getMemtableOffheapSpaceInMb

          public static long getMemtableOffheapSpaceInMb()

    - #### getMemtableAllocationType

          public static Config.MemtableAllocationType getMemtableAllocationType()

    - #### getMemtableCleanupThreshold

          public static java.lang.Float getMemtableCleanupThreshold()

    - #### getIndexSummaryResizeIntervalInMinutes

          public static int getIndexSummaryResizeIntervalInMinutes()

    - #### hasLargeAddressSpace

          public static boolean hasLargeAddressSpace()

    - #### getTracetypeRepairTTL

          public static int getTracetypeRepairTTL()

    - #### getTracetypeQueryTTL

          public static int getTracetypeQueryTTL()

    - #### getOtcCoalescingStrategy

          public static java.lang.String getOtcCoalescingStrategy()

    - #### getOtcCoalescingWindow

          public static int getOtcCoalescingWindow()

    - #### getOtcCoalescingEnoughCoalescedMessages

          public static int getOtcCoalescingEnoughCoalescedMessages()

    - #### setOtcCoalescingEnoughCoalescedMessages

          public static void setOtcCoalescingEnoughCoalescedMessages(int otc_coalescing_enough_coalesced_messages)

    - #### getOtcBacklogExpirationInterval

          public static int getOtcBacklogExpirationInterval()

    - #### setOtcBacklogExpirationInterval

          public static void setOtcBacklogExpirationInterval(int intervalInMillis)

    - #### getWindowsTimerInterval

          public static int getWindowsTimerInterval()

    - #### getPreparedStatementsCacheSizeMB

          public static long getPreparedStatementsCacheSizeMB()

    - #### getThriftPreparedStatementsCacheSizeMB

          public static long getThriftPreparedStatementsCacheSizeMB()

    - #### enableUserDefinedFunctions

          public static boolean enableUserDefinedFunctions()

    - #### enableScriptedUserDefinedFunctions

          public static boolean enableScriptedUserDefinedFunctions()

    - #### enableScriptedUserDefinedFunctions

          public static void enableScriptedUserDefinedFunctions(boolean enableScriptedUserDefinedFunctions)

    - #### enableUserDefinedFunctionsThreads

          public static boolean enableUserDefinedFunctionsThreads()

    - #### getUserDefinedFunctionWarnTimeout

          public static long getUserDefinedFunctionWarnTimeout()

    - #### setUserDefinedFunctionWarnTimeout

          public static void setUserDefinedFunctionWarnTimeout(long userDefinedFunctionWarnTimeout)

    - #### enableMaterializedViews

          public static boolean enableMaterializedViews()

    - #### getUserDefinedFunctionFailTimeout

          public static long getUserDefinedFunctionFailTimeout()

    - #### setUserDefinedFunctionFailTimeout

          public static void setUserDefinedFunctionFailTimeout(long userDefinedFunctionFailTimeout)

    - #### getUserFunctionTimeoutPolicy

          public static Config.UserFunctionTimeoutPolicy getUserFunctionTimeoutPolicy()

    - #### setUserFunctionTimeoutPolicy

          public static void setUserFunctionTimeoutPolicy(Config.UserFunctionTimeoutPolicy userFunctionTimeoutPolicy)

    - #### getGCLogThreshold

          public static long getGCLogThreshold()

    - #### getEncryptionContext

          public static EncryptionContext getEncryptionContext()

    - #### getGCWarnThreshold

          public static long getGCWarnThreshold()

    - #### isCDCEnabled

          public static boolean isCDCEnabled()

    - #### setCDCEnabled

          public static void setCDCEnabled(boolean cdc_enabled)

    - #### getCDCLogLocation

          public static java.lang.String getCDCLogLocation()

    - #### getCDCSpaceInMB

          public static int getCDCSpaceInMB()

    - #### setCDCSpaceInMB

          public static void setCDCSpaceInMB(int input)

    - #### getCDCDiskCheckInterval

          public static int getCDCDiskCheckInterval()

    - #### setEncryptionContext

          public static void setEncryptionContext(EncryptionContext ec)

    - #### searchConcurrencyFactor

          public static int searchConcurrencyFactor()

    - #### isUnsafeSystem

          public static boolean isUnsafeSystem()

    - #### setBackPressureEnabled

          public static void setBackPressureEnabled(boolean backPressureEnabled)

    - #### backPressureEnabled

          public static boolean backPressureEnabled()

    - #### setBackPressureStrategy

          public static void setBackPressureStrategy(BackPressureStrategy strategy)

    - #### getBackPressureStrategy

          public static BackPressureStrategy getBackPressureStrategy()

Copyright © 2018 The Apache Software Foundation